Package org.apache.commons.collections4.bag

# Class AbstractBagDecorator<E>

java.lang.Object
org.apache.commons.collections4.collection.AbstractCollectionDecorator<E>
org.apache.commons.collections4.bag.AbstractBagDecorator<E>

Type Parameters:
  `E` - the type of elements in this bag

All Implemented Interfaces:
  `Serializable`, `Iterable<E>`, `Collection<E>`, `Bag<E>`

Direct Known Subclasses:
  `AbstractSortedBagDecorator`, `CollectionBag`, `UnmodifiableBag`

public abstract class AbstractBagDecorator<E> extends AbstractCollectionDecorator<E> implements Bag<E>
Decorates another `Bag` to provide additional behavior.

Methods are forwarded directly to the decorated bag.

Since:
  3.0
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractBagDecorator()`
  Constructor only used in deserialization, do not use otherwise.
  `protected`
  `AbstractBagDecorator(Bag<E> bag)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(E object, int count)`
  Adds `nCopies` copies of the specified object to the Bag.
  `protected Bag<E>`
  `decorated()`
  Gets the bag being decorated.
  `boolean`
  `equals(Object object)`
  `int`
  `getCount(Object object)`
  Returns the number of occurrences (cardinality) of the given object currently in the bag.
  `int`
  `hashCode()`
  `boolean`
  `remove(Object object, int count)`
  Removes `nCopies` copies of the specified object from the Bag.
  `Set<E>`
  `uniqueSet()`
  Returns a `Set` of unique elements in the Bag.

  ### Methods inherited from class org.apache.commons.collections4.collection.AbstractCollectionDecorator

  `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, removeIf, retainAll, setCollection, size, toArray, toArray, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.Bag

  `add, containsAll, iterator, remove, removeAll, retainAll, size`

  ### Methods inherited from interface java.util.Collection

  `addAll, clear, contains, isEmpty, parallelStream, removeIf, spliterator, stream, toArray, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

- ## Constructor Details

  - ### AbstractBagDecorator

    protected AbstractBagDecorator()
    Constructor only used in deserialization, do not use otherwise.
    Since:
      3.1

  - ### AbstractBagDecorator

    protected AbstractBagDecorator(Bag<E> bag)
    Constructor that wraps (not copies).
    Parameters:
      `bag` - the bag to decorate, must not be null
    Throws:
      `NullPointerException` - if bag is null

- ## Method Details

  - ### add

    public boolean add(E object, int count)
    Description copied from interface: `Bag`
    Adds `nCopies` copies of the specified object to the Bag.

    If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

    Specified by:
      `add` in interface `Bag<E>`
    Parameters:
      `object` - the object to add
      `count` - the number of copies to add
    Returns:
      `true` if the object was not already in the `uniqueSet`

  - ### decorated

    protected Bag<E> decorated()
    Gets the bag being decorated.
    Overrides:
      `decorated` in class `AbstractCollectionDecorator<E>`
    Returns:
      the decorated bag

  - ### equals

    public boolean equals(Object object)
    Specified by:
      `equals` in interface `Collection<E>`
    Overrides:
      `equals` in class `Object`

  - ### getCount

    public int getCount(Object object)
    Description copied from interface: `Bag`
    Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.
    Specified by:
      `getCount` in interface `Bag<E>`
    Parameters:
      `object` - the object to search for
    Returns:
      the number of occurrences of the object, zero if not found

  - ### hashCode

    public int hashCode()
    Specified by:
      `hashCode` in interface `Collection<E>`
    Overrides:
      `hashCode` in class `Object`

  - ### remove

    public boolean remove(Object object, int count)
    Description copied from interface: `Bag`
    Removes `nCopies` copies of the specified object from the Bag.

    If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

    Specified by:
      `remove` in interface `Bag<E>`
    Parameters:
      `object` - the object to remove
      `count` - the number of copies to remove
    Returns:
      `true` if this call changed the collection

  - ### uniqueSet

    public Set<E> uniqueSet()
    Description copied from interface: `Bag`
    Returns a `Set` of unique elements in the Bag.

    Uniqueness constraints are the same as those in `Set`.

    Specified by:
      `uniqueSet` in interface `Bag<E>`
    Returns:
      the Set of unique Bag elements